Fractal padre,madre,hijo;
PFont fuente;
/*
  adnPadre, adnMadre y adnHijo son arreglos de tipo flotante que tienen cifrado
 los genes de cada una de las imágenes, poseen 28 celdas cada uno.
 */
float adnPadre[] = { 
  2 , 5 , // cantidad , nivel
  0.7 , 0.1 , 0.4 , //factores de tamaño
  0.2 , 0.75 , 0.8 , //posiciones en x
  0.5 , 0.5 , 0.5 , //posiciones en y
  radians(-10) , radians(0) , radians(15) , //angulos
  60,255,255, //HSB inicial relleno
  10,0,0 ,  //HSB incremento relleno
  180, // transparencia
  0,0,0, //HSB inicial contorno
  30,2,10, //HSB incremento contorno
  255 //transparencia contorno
};

float adnMadre[] = { 
  2 , 6 , // cantidad , nivel
  0.6 , 0.8 , 0.75 , //factores de tamaño
  0.3 , 0.7 , 0.8 , //posiciones en x
  0.6 , 0.4 , 0.5 , //posiciones en y
  radians(5) , radians(-6) , radians(10) , //angulos
  170,155,255, //HSB inicial relleno
  10,10,0 ,  //HSB incremento relleno
  100, // transparencia
  0,0,255, //HSB inicial contorno
  30,2,-10, //HSB incremento contorno
  100 //transparencia contorno
};
void setup(){
  size(800,600);
  fuente = loadFont("arial.vlw");
  textFont( fuente , 24 );
  //aquí se les pasa a cada uno de los fractales sendas cadenas de adn
  padre = new Fractal( 300 , 200 , adnPadre );
  madre = new Fractal( 300 , 200 , adnMadre );

  // la función crossOver() se encarga de una nueva cadena de ADN, combinando
  // los ADN del padre y la madre
  float adnHijo[] = crossOver( adnPadre , adnMadre );
  hijo = new Fractal( 300 , 200 , adnHijo );
}
void draw(){
  background(0);
  padre.dibujar( 50 , 50 );
  madre.dibujar( 450 , 50 );
  hijo.dibujar( 250 , 350 );
  
  fill(255);
  text("padre",50,40);
  text("madre",450,40);
  text("hijo",250,340);
  text("Click con el mouse para obtener nuevos hijos",50,580);
}
void mousePressed(){
  float adnHijo[] = crossOver( adnPadre , adnMadre );
  hijo = new Fractal( 300 , 200 , adnHijo );
}















