/**
Construcciones de fractales con rectangulos mediante recursion. - 
Emiliano Causa 2011 - 
emiliano.causa@gmail.com
**/
int cantidad = 2;
float factor[] = { 0.7 , 0.3 };
float x[] = { 0.4 , 0.8 };
float y[] = { 0.5 , 0.6 };
float ang[] = { radians(-10) , radians(50) };
//---------------------------------------

void setup() {
  size( 400, 300 );
  smooth();
  stroke( 0 , 0 , 155 , 50 );
  fill( 0 , 0 , 255 , 50 );
}
//---------------------------------------

void draw() {
  background(200,200,255);
  fractal( 10, 400, 300 );
  noLoop();
}
//---------------------------------------

void fractal( int nivel, float ancho, float alto ) {
  if ( nivel>0 ) {

    rectMode( CENTER );      

    for ( int i=0 ; i<cantidad ; i++ ) {
      pushMatrix();

      translate( ancho*x[i], alto*y[i] );
      rotate( ang[i] );

      rect( 0, 0, ancho*factor[i], alto*factor[i] );

      translate( ancho*factor[i]*-0.5, alto*factor[i]*-0.5 );
      fractal( nivel-1, ancho*factor[i], alto*factor[i] );

      popMatrix();
    }
  }
}

