/**
 * Vida Artificial - /
 * Emiliano Causa - 2007 / www.biopus.com.ar / www.emiliano-causa.com.ar / 
 * En este ejemplo se muestra como transformar coordenadas polares en rectangualres para
 * lograr movimiento con direccionalidad. Haga click para volver a iniciar los organismos.
 **/
Organismo[] animales;  //Un arreglo de animales
int cantAnimales;  //Define la cantidad de animales
//---------------------------- 
void setup(){

  size(600,400);
  frameRate(30);
  cantAnimales = 20;   //Se establece la cantidad de animales
  iniciar(); //ejecuta la inicialización
  colorMode(HSB,300);
  background(300);  
}
//---------------------------- 
void draw(){
  
  fill(300,5);  // lava los colores de lo 
  noStroke();  // dibujado en el
  rect(width/2,height/2,width,height); // fotograma anterior
  
  stroke(200,100,100,200);
  fill(200,300,300,50);
  
  for(int i=0;i<cantAnimales;i++){  //se recorre cada animal y :
    animales[i].mover();  //cada uno amina hacia la comida y actualiza su energia
    animales[i].dibujar();  //dibuja cada animal
  }

}
//---------------------------- 
void mousePressed(){

  iniciar(); //ejecuta la inicialización

}
//---------------------------- 
void iniciar(){

  animales = new Organismo[cantAnimales];  //Se inicia el arreglo
  for(int i=0;i<cantAnimales;i++){   //se recorre cada animal
    animales[i] = new Organismo();  // se inicia cada animal
  }

}

