/**
 * Vida Artificial - /
 * Emiliano Causa - 2007 / www.biopus.com.ar / www.emiliano-causa.com.ar / 
 * En este ejemplo cada especie tiene una conducta en relación a individuos
 * de igual y diferente especie. Se programó las conductas
 * de cada una de las especies y los tipos de relaciones entre ellas.
 **/
Ecosistema bio; //declara un objeto ecosistema
//---------------------------- 

void setup(){
  size(600,400);
  frameRate(30);
  colorMode(HSB,300);
  rectMode(CENTER);
  background(300);  
  bio = new Ecosistema( 40 , 4 ); //define un ecosistema de 40 organismos con
  //una division del territorio de 4x4 celdas

}
//---------------------------- 

void draw(){

  fill(50,50,300,30);  // lava los colores de lo 
  noStroke();  // dibujado en el
  rect(width/2,height/2,width,height); // fotograma anterior

  bio.revisar_Territorio();
  bio.resolver_Encuentros_Organismos();
  bio.accionar_Organismos();
  bio.dibujar_Organismos();

}
//---------------------------- 

void mousePressed(){
  bio.iniciar_Organismos(); //ejecuta la inicialización
}
//---------------------------- 


